# Component 12 - multiple trials

import random

# functions go here...

def numcheck(question, type):

    if type == int:
        error = "Please enter an integer that is more than 0"
    else:
        error = "Please enter a number that is more than 0"

    valid = False
    while not valid:
        try:
            response = type(input(question))
            if response > 0:
                return response
            else:
                print(error)
        except ValueError:
            print(error)

# main routine goes here

summary = []

# Ask for price & number of trials
items = input("Enter a target word of the # of items: ")
price = numcheck("How much does each purchase cost? $", float)
trials = numcheck("How many trials would you like? ", int)
print()

trials_complete = 0

# Run program for each trial
while trials_complete < trials:

    target_list = []
    choice_list = []
    purchase_list = []

    try:
        items = int(items)      # replace with integer checking code from component 5 in due course
        for number in range (1, items + 1):
            target_list.append(number)
            choice_list.append(number)

    except ValueError:
        for letter in items:
            target_list.append(letter)
            if letter not in choice_list:
                choice_list.append(letter)

    while len(target_list) > 0:
        count = 0
        chosen = random.choice(choice_list)
        purchase_list.append(chosen)
        if chosen in target_list:
            target_list.remove(chosen)

    count += 1
    print("Trial {}:".format(trials_complete + 1), end=" ")
    for item in purchase_list:
        print(item, end=",")
    print()

    summary_row = "Trial {}: {} items  \t  Cost: ${:.2f}".format(trials_complete + 1, len(purchase_list), len(purchase_list) * price)

    summary.append(summary_row)
    trials_complete += 1

# Show summary
print()
print("***** Summary *****")
for item in summary:
    print(item, end="\n")
