# CR Component 2 - getting input

# To Do
# Ask for car # (should be 1- 6 <1 die> or 1 - 12 <2 dice>
# Ask for distance (should be 1 - 5)


# Integer checking function goes here
def intcheck(question, low=None, high=None):

    # sets up error messages
    if low is not None and high is not None:
            error = "Please enter an integer between {} and {} " \
                    "(inclusive)".format(low, high)
    elif low is not None and high is None:
        error = "Please enter an integer that is more than or " \
                "equal to {}".format(low)
    elif low is None and high is not None:
        error = "Please enter an integer that is less than or " \
                "equal to {}".format(high)
    else:
        error = "Please enter an integer"

    while True:

        try:
            response = int(input(question))

            # Checks response is not too low
            if low is not None and response < low:
                print(error)
                continue

            # Checks response is not too high
            if high is not None and response > high:
                print(error)
                continue

            return response

        except ValueError:
            print(error)
            continue

# Main Routine Goes here

keep_going = ""
while keep_going == "":
    # Get Car #
    num_dice = intcheck("How many dice should we use (1 or 2)? ", 1, 2)     # from component 1

    if num_dice == 1:
        upper = 6
    else:
        upper = 12

    car_num = intcheck("What car would you like (1 - {})? ".format(upper), 1, upper)
    distance = intcheck("Choose a race distance (5 - 15): ",5, 15)
    print("You chose {} die, opted for car # {} and asked for a distance of {} steps".format(num_dice, car_num, distance))

    keep_going = input("Again?")
